﻿using System.Collections.Generic;
using System.Diagnostics;

namespace X03.PageElementVisitors
{
	public class PageElementCollector : PageElementVisitor
	{
		public class Tuple
		{
			public PageElement Element { get; set; }
			public string Position { get; set; }
			public override int GetHashCode()
			{
				return base.GetHashCode();
			}
			public override string ToString()
			{
				return "[" + this.Element.ToString() + ", " + this.Position.ToString() + "]";
			}
			public override bool Equals(object obj)
			{
				var t = (Tuple)obj;
				return (this.Element == t.Element && this.Position == t.Position);
			}
			public Tuple(PageElement element, string position)
			{
				Debug.Assert(position == "pre" || position == "post");

				this.Element = element;
				this.Position = position;
			}
		}

		public List<Tuple> Collection { get; protected set; }

		public override void Visit(PageElement element)
		{
			this.Collection.Add(new Tuple(element, "pre"));

			foreach (var child in element.Children)
			{
				child.Accept(this);
			}

			this.Collection.Add(new Tuple(element, "post"));
		}

		public PageElementCollector()
		{
			this.Collection = new List<Tuple>();
		}
	}
}
