﻿using System;
using System.Collections.Generic;
using System.Text.RegularExpressions;

namespace X03.PageElements.Notations
{
	public class Lf : PageElements.Notation, Plugin.PageElement, Plugin.Findable
	{
		private const string _Pattern = @"(?:\r\n|\r|\n)";

		override public void Accept(PageElementVisitor visitor)
		{
			visitor.Visit(this);
		}

		public string ToWikitext()
		{
			return this.Wikitext;
		}

		public string ToHtml()
		{
			return Regex.Replace(this.Wikitext, Lf._Pattern, "<br />\n", RegexOptions.Singleline);
		}

		public string ToPlaintext()
		{
			throw new NotImplementedException();
		}

		public override void InAction()
		{
			foreach (var child in this.Children)
				child.InAction();
		}

		override public string CreateTag()
		{
			return this.GetType().Name + ":" + "";
		}

		public float SimilarityTo2(PageElement that)
		{
			return 1F;
		}

		new static public string Pattern
		{
			get { return Lf._Pattern + "+"; }
		}

		public Lf(PageElement parent, Match m, HashSet<Type> ignoreClasses)
			: base(parent, m, ignoreClasses)
		{
			this.WikitextPre = m.Groups[0].Value;
			this.WikitextPost = "";
			//string content = m.Groups[1].Value;

			//ignoreClasses.Add(this.GetType());
			//this.Children.AddRange(PageElements.Notation.Tokenize(parent, content, ignoreClasses));
			//ignoreClasses.Remove(this.GetType());
		}
	}
}
