﻿using System;
using System.Collections.Generic;
using System.Reflection;

namespace X03.PageElements
{
	/// <summary>
	/// プレーンテキスト系要素。
	/// リフレクションを使用するクラス。
	/// </summary>
	abstract public class Plain : PageElement, Plugin.PageElement
	{
		// プラグインからクラス定義読み込み
		static public Type[] GetPluginClasses()
		{
			var ret = new List<Type>();
			foreach (var t in Assembly.GetExecutingAssembly().GetTypes())
			{
				if (t.IsSubclassOf(typeof(X03.PageElements.Plain)))
				{
					ret.Add(t);
				}
			}
			return ret.ToArray();
		}

		static public PageElements.Plain Construct(PageElement parent, string content, HashSet<Type> ignoreClasses)
		{
			PageElements.Plain elementInstance = null;
			foreach (var elementClass in GetPluginClasses())
			{
				if (!ignoreClasses.Contains(elementClass))
				{
					elementInstance = (PageElements.Plain)Assembly.GetAssembly(elementClass).CreateInstance(elementClass.FullName, false, BindingFlags.CreateInstance, null, new object[] { parent, content, ignoreClasses }, null, null);
				}
			}

			return elementInstance;
		}

		public Plain(PageElement parent, HashSet<Type> ignoreClasses)
			: base(parent)
		{
			this.Children = new List<PageElement>();
		}
	}
}
